
SuperStrict

Type TTile

	Global _width:Int	= 32		'breite des Tiles
	Global _height:Int     = 15		'hhe des Tiles

	Field _xPos:Int			'x-position
	Field _yPos:Int			'y-position
	Field _hPos:Int			'h-position (hhe)
	
	Field _material:Int		'material (frame nummer)
	
	'seter (Ich glaube zu denen muss ich nichts sagen, oder?)
	
	Method setXPos( xPos:Int )
	
		_xPos = xPos
	
	EndMethod
	
	Method setYPos( yPos:Int )
	
		_yPos = yPos
	
	EndMethod
	
	Method setHPos( hPos:Int )
	
		_hPos = hPos
	
	EndMethod
	
	Method setMaterial( material:Int )
	
		_material = material
	
	EndMethod
	
	'geter (Ich glaube zu denen muss ich auch nichts sagen)
	
	Method getXPos:Int()
	
		Return _xPos
	
	EndMethod
	
	Method getYPos:Int()
	
		Return _yPos
	
	EndMethod
	
	Method getHPos:Int()
	
		Return _hPos
	
	EndMethod
	
	Method getMaterial:Int()
	
		Return _material
	
	EndMethod
	
	'functions / methods
	
	Function Create:TTile( xPos:Int,yPos:Int,hPos:Int,material:Int )
	
		Local n:TTile = New TTile		        'neues TTile objekt erstellen
		
			n.setXPos( xPos )			'x-position bergeben
			n.setYPos( yPos )		        'y-position bergeben
			n.setHPos( hPos )                      'h-position bergeben
			n.setMaterial( material )	        'material-nummer bergeben
		
		Return n						'fertiges TTile zurckgeben
	
	EndFunction
	
	Method draw() 'diese Methode wird unter dem Code besprochen
		
		DrawImage tileset,_xPos * zoom - (scrollX*TTile._width), _yPos * zoom - _hPos - (scrollY*TTile._height),_material
	
	EndMethod

EndType

'---------------------

Graphics 640, 480, 32, 60, 2 

Global map:TTile [ 256,256 ]
Global colorMap:TPixmap

Global scrollX:Int = 0
Global scrollY:Int = 0

Global screenWidth:Int =  GraphicsWidth() / TTile._width          'wie viele Tiles diagonal auf den Bildschim passen
Global screenHeight:Int = GraphicsHeight() / TTile._height * 2  'und wie viele horizontal drauf passen

Global zoom:Float = 1

Global mainTimer:TTimer = CreateTimer( 60 )

Global tileset:TImage = LoadAnimImage( "gfx/tileset.png",TTile._width, 128,0,2 ) 'Tileset als AnimImage laden
Global fps:TFPS = TFPS.Create()

'mainloop

newMap() 'neue leere Map erstellen

renderMap()

Repeat
Cls

	Local old:Int = MilliSecs()

	renderMap()
	drawMap()		'Map neu Zeichnen
	
	If MouseDown( 1 )
	
		Local pixel:Int = ReadPixel( colorMap,MouseX(),MouseY() )
		
		Local x:Int = getpixmapred( colorMap,MouseX(),MouseY() )
		Local y:Int = getpixmapgreen( colorMap,MouseX(),MouseY() )
		
		map[ x,y ].setHPos( MouseZ() )
	
	EndIf
	
	DrawText MilliSecs() - old + " FPS: " + fps.get(),0,0

	WaitTimer( mainTimer )	'auf den Timer warten...
	
	fps.Update()
	
Flip 0
Until AppTerminate() Or KeyDown( key_escape )


Function newMap()
	
	For Local y:Int = 0 To 255
		For Local x:Int = 0 To 255
		
			Local xpos:Int = ((x*TTile._width)+(y Mod 2)*(TTile._width/2))	        'x-position berechnen
			Local ypos:Int = (y*(TTile._height/2 + 1))						'y-position berechnen 
			
			map[ x,y ] = TTile.Create( xPos,yPos,0,1 )		'neues TTile erstellen mit x,y,h,m parametern
			
		Next
	Next

EndFunction

Function drawMap()

	SetScale( zoom,zoom )	'scale auf zoom setzen

	For Local y:Int = scrollY To scrollY + screenHeight + 1
		For Local x:Int = scrollX To scrollX + screenWidth - 1
		
			map[ x,y ].draw()		'TTile.Draw() Methode des jeweiligen Tiles aufrufen
			
		Next
	Next
	
	SetScale( 1,1 )	'scale auf "normal" setzen (1,1)

EndFunction

Function RenderMap()

	Cls

	SetScale( zoom,zoom )	'scale auf zoom setzen

	For Local y:Int = scrollY To scrollY + screenHeight + 1
		For Local x:Int = scrollX To scrollX + screenWidth - 1
		
			SetColor x,y,0				'farbe f das Objekt setzen
		
			Local mat:Int = map[ x,y ].getMaterial()	'altes Material speichern
			map[ x,y ].setMaterial( 0 )		'Material auf 0 setzten = weies Tile
			map[ x,y ].draw()				'TTile.Draw() Methode des jeweiligen Tiles aufrufen
			map[ x,y ].setMaterial( mat )	'altes material zurck geben
			
		Next
	Next
	
	colorMap:TPixmap = GrabPixmap( 0,0,GraphicsWidth(),GraphicsHeight() )	'Color map "befllen"
	
	Cls
	
	SetColor 255,255,255
	
	SetScale( 1,1 )	'scale auf "normal" setzen (1,1)

EndFunction


Function getPixmapRed:Int(pixmap:TPixmap,x:Int,y:Int)

	Local position:Int = ReadPixel(pixmap,x,y)
	
	Return (position Shl 8) Shr 24

EndFunction

Function getPixmapGreen:Int(pixmap:TPixmap,x:Int,y:Int)

	Local position:Int = ReadPixel(pixmap,x,y)
	
	Return (position Shl 16) Shr 24

EndFunction

Function getPixmapBlue:Int(pixmap:TPixmap,x:Int,y:Int)

	Local position:Int = ReadPixel(pixmap,x,y)
	
	Return (position Shl 24) Shr 24

EndFunction

Function getPixmapAlpha:Int(pixmap:TPixmap,x:Int,y:Int)

	Local position:Int = ReadPixel(pixmap,x,y)
	
	Return position Shr 24

EndFunction

Type tFps	

	Field old:Int
	Field fps:Int

	Field count:Int
	Field time:Int
	
	Field timer:TTimer
	
	Rem
		bbdoc: 	setzt den kompletten FPS-counter zurck
		returns: FPS :int 
		about:	Muss in der Hauptschleife mit FPS.Update() Aktualiesiert werden
	
	EndRem

	Method Reset()
	
		time 	:Int		= 0
		count 	:Int 	= 0
		fps 		:Int		= 0
		old		:Int 	= 0
		timer	:ttimer 	= CreateTimer(1)
	
	EndMethod
	
	Rem
		bbdoc: 	Updated den FPS-counter
		returns: 
		about:	Muss in der Hauptschleife nach Flip passieren
	
	EndRem
	
	Method Update()
	
	count:+ 1
	time = TimerTicks(timer) Mod 2
	
		If time <> old Then
			fps = count
			count = 0
			old = time
		EndIf
	
	EndMethod
	
	Rem
		bbdoc: 	Gibt FPS zurck
		returns: FPS :int 
		about:	Muss in der Hauptschleife mit FPS.Update() Aktualiesiert werden
	
	EndRem
	
	Method Get:Int()
	
		Return fps
	
	EndMethod
	
	Rem
		bbdoc: 	Erstellt einen neuen FPS-counter
		returns: 
		about:	Muss in der Hauptschleife mit FPS.Update() Aktualiesiert werden
	
	EndRem
	
	Function Create:TFps()
	
		Local n:TFps = New TFps
		
			n.timer = CreateTimer(1)
			
		Return n
	
	EndFunction
	
EndType
